# Class VulkanSpecializationMapEntry.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanSpecializationMapEntry.Builder

Enclosing class:
  `VulkanSpecializationMapEntry`

public static final class VulkanSpecializationMapEntry.Builder extends Object
Builds instances of type `VulkanSpecializationMapEntry`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanSpecializationMapEntry`
  `build()`
  Builds a new `VulkanSpecializationMapEntry`.
  `final VulkanSpecializationMapEntry.Builder`
  `from(VulkanSpecializationMapEntryType instance)`
  Fill a builder with attribute values from the provided `VulkanSpecializationMapEntryType` instance.
  `final VulkanSpecializationMapEntry.Builder`
  `setConstantID(int constantID)`
  Initializes the value for the `constantID` attribute.
  `final VulkanSpecializationMapEntry.Builder`
  `setOffset(long offset)`
  Initializes the value for the `offset` attribute.
  `final VulkanSpecializationMapEntry.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanSpecializationMapEntry.Builder from(VulkanSpecializationMapEntryType instance)
    Fill a builder with attribute values from the provided `VulkanSpecializationMapEntryType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setConstantID

    public final VulkanSpecializationMapEntry.Builder setConstantID(int constantID)
    Initializes the value for the `constantID` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `constantID`.

    Parameters:
      `constantID` - The value for constantID
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanSpecializationMapEntry.Builder setOffset(long offset)
    Initializes the value for the `offset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `offset`.

    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanSpecializationMapEntry.Builder setSize(long size)
    Initializes the value for the `size` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `size`.

    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanSpecializationMapEntry build()
    Builds a new `VulkanSpecializationMapEntry`.
    Returns:
      An immutable instance of VulkanSpecializationMapEntry
    Throws:
      `IllegalStateException` - if any required attributes are missing